"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var StochasticGradientDescent = function () {
    function StochasticGradientDescent(learningRate) {
        _classCallCheck(this, StochasticGradientDescent);

        this.learningRate = learningRate;
        this.optimizeWeights = this.optimizeWeights.bind(this);
    }

    _createClass(StochasticGradientDescent, [{
        key: "optimizeWeights",
        value: function optimizeWeights(weights, weightErrorGradients) {
            //Defining locally speeds up the loop below by reducing object property access
            var learningRate = this.learningRate;

            for (var i = 0, len = weights.length; i < len; i++) {
                weights[i] -= learningRate * weightErrorGradients[i];
            }
        }
    }]);

    return StochasticGradientDescent;
}();

exports.default = StochasticGradientDescent;